use crate::prelude::*;
use library_loader::load_function_ptrs;

load_function_ptrs!(DeferredOperationsFunctions, {
    vkCreateDeferredOperationKHR(
        device: VkDevice,
        pAllocator: *const VkAllocationCallbacks,
        pDeferredOperation: *mut VkDeferredOperationKHR
    ) -> VkResult,

    vkDestroyDeferredOperationKHR(
        device: VkDevice,
        deferredOperation: VkDeferredOperationKHR,
        pAllocator: *const VkAllocationCallbacks
    ) -> (),

    vkGetDeferredOperationMaxConcurrencyKHR(
        device: VkDevice,
        deferredOperation: VkDeferredOperationKHR
    ) -> u32,

    vkGetDeferredOperationResultKHR(
        device: VkDevice,
        deferredOperation: VkDeferredOperationKHR
    ) -> VkResult,

    vkDeferredOperationJoinKHR(
        device: VkDevice,
        deferredOperation: VkDeferredOperationKHR
    ) -> VkResult,
});

impl DeferredOperationsFunctions {
    pub fn new(instance_functions: &InstanceFunctions, device: VkDevice) -> Self {
        Self::load(|name| unsafe {
            instance_functions.vkGetDeviceProcAddr(device, name.as_ptr()) as *const std::ffi::c_void
        })
    }
}
