use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
pub struct VkPhysicalDeviceProperties2KHR {
    pub sType: VkStructureType,
    pub pNext: *mut c_void,
    pub properties: VkPhysicalDeviceProperties,
}

impl VkPhysicalDeviceProperties2KHR {
    pub fn new(properties: VkPhysicalDeviceProperties) -> Self {
        VkPhysicalDeviceProperties2KHR {
            sType: VK_STRUCTURE_TYPE_PHYSICAL_DEVICE_PROPERTIES_2,
            pNext: ptr::null_mut(),
            properties,
        }
    }
}

impl Default for VkPhysicalDeviceProperties2KHR {
    fn default() -> Self {
        Self::new(VkPhysicalDeviceProperties::default())
    }
}

unsafe impl Sync for VkPhysicalDeviceProperties2KHR {}
unsafe impl Send for VkPhysicalDeviceProperties2KHR {}

impl_pnext_out!(
    VkPhysicalDeviceProperties2KHR,
    VkPhysicalDeviceRayTracingPropertiesKHR
);

impl_pnext_out!(
    VkPhysicalDeviceProperties2KHR,
    VkPhysicalDeviceDescriptorIndexingPropertiesEXT
);

impl_pnext_out!(
    VkPhysicalDeviceProperties2KHR,
    VkPhysicalDeviceAccelerationStructurePropertiesKHR
);
